#property indicator_separate_window
#property indicator_level1 0
#property indicator_level2 0
#property indicator_level3 0
#property indicator_color1 Red

//extern int Timeframe = 5;
static string Symbol_1;
extern string Symbol_2;
extern int NBars = 500;
extern double koeff = 1.3;
string filename;

double S1Bid, S1Ask, S2Bid, S2Ask, S1Spread, S2Spread, S1Point, S2Point;

double Spread[];

void PrintToFile(string file_name, string value)
{
	int handle = FileOpen(file_name, FILE_CSV | FILE_READ | FILE_WRITE);
	if (handle > 0)
	{
		FileSeek(handle, 0, SEEK_END);
		FileWrite(handle, value);
		FileClose(handle);
	}
}

int init()
{
	filename = "spread.csv";
	FileDelete(filename);
	
	SetIndexBuffer(0,Spread);
	SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,1,Red);
	
	Symbol_1 = Symbol();
	
	return(0);
}

int start()
{
	int k;
	double N = 0;
	double Sum = 0;
	double max = 0, min = 0;
	
	ArrayInitialize(Spread, 0);
	S1Bid = MarketInfo(Symbol_1, MODE_BID);
	S1Ask = MarketInfo(Symbol_1, MODE_ASK);
	S2Bid = MarketInfo(Symbol_2, MODE_BID);
	S2Ask = MarketInfo(Symbol_2, MODE_ASK);
	S1Spread = MarketInfo(Symbol_1, MODE_SPREAD);
	S2Spread = MarketInfo(Symbol_2, MODE_SPREAD);
	S1Point = MarketInfo(Symbol_1, MODE_POINT);
	S2Point = MarketInfo(Symbol_2, MODE_POINT);
	
	for(k = 0; k < iBars(Symbol_1, Period()); k++)
	{
		if (N == NBars)
			break;
			
  	int symb2Shift = iBarShift(Symbol_2, Period(),iTime(Symbol_1, Period(),k),true);
  	if(symb2Shift != -1)
  	{
   		Spread[k] = iClose(Symbol_1, Period(),k) - iClose(Symbol_2, Period(),symb2Shift);
     	Sum += Spread[k];
     	N++;
     	
     	if (max == 0)
     		max = Spread[k];
     	
     	if (min == 0)
     		min = Spread[k];
     	
     	if (Spread[k] > max)
     		max = Spread[k];
     	if (Spread[k] < min)
     		min = Spread[k];
  	}
  	else
  	{
     	Spread[k] = 0;
  	}

	}
	double av = Sum / N;
	string message = "Average spread: " +  DoubleToStr(av, Digits) + "\nMax: " + 
									 DoubleToStr(max, Digits) + "\nMin: " + DoubleToStr(min, Digits);
//	Comment(message);

	N = 0;
	for(k = 0; k < iBars(Symbol_1, Period()); k++)
	{
		if (N == NBars)
			break;
			
		if (Spread[k] == 0)
			continue;
		else
		{
     	Spread[k] = Spread[k] - av;
     	N++;
  	}
	}

	N = 0;
	double sum_minus = 0, sum_plus = 0;
	int num_minus = 0, num_plus = 0;
	for(k = 0; k < iBars(Symbol_1, Period()); k++)
	{
		if (N == NBars)
			break;
			
		if (Spread[k] == 0)
			continue;
		else
     	N++;
     	
    if (Spread[k] > 0)
    {
    	sum_plus += Spread[k];
    	num_plus += 1;
    }
     	
    if (Spread[k] < 0)
    {
    	sum_minus += Spread[k];
    	num_minus += 1;
    }
	}

  if (num_plus > 0)
  	SetLevelValue(1, koeff * sum_plus / num_plus);
  
  if (num_minus > 0)
  	SetLevelValue(2, koeff * sum_minus / num_minus);

	return(0);
}